function G = GQP(etan2, etan1, qp, z)
% function G(qp)
    
    global Ndecim

    % variable etan2, etan1 and z (taken every Ndecim value of the efficiency)
    etan2 = etan2(1 : Ndecim : length(etan2));
    etan1 = etan1(1 : Ndecim : length(etan1));
    z = z(1 : Ndecim : length(z));
    % time step size for z1 and z2
    dz = (z(end) - z(1)) / (length(z) -  1);
    
    % Simpson numerical integration for z1 and z2
    % ---------------------------------------------------------------------
    % simpson1D -> odd number
    if (rem(length(z), 2) == 0)
        z = z(1 : end - 1);
        etan1 = etan1(1 : end - 1);
        etan2 = etan2(1 : end - 1);
        % new time step size for z1 and z2
        dz = (z(end) - z(1)) / (length(z) -  1);
    end
    % simpson 1D
    sim1d = ones(1, length(z));
    sim1d = 4 * (rem(find(sim1d), 2) == 0) + 2 * (rem(find(sim1d), 2) == 1);
    sim1d(1) = 1;
    sim1d(end) = 1;
    % simpson 2D
    [sim2d1, sim2d2] = meshgrid(sim1d);
    sim2d = sim2d1 .* sim2d2;
    % ---------------------------------------------------------------------

    % 2D meshgrid
    [etan2_z1, etan2_z2] = meshgrid(etan2);
    [etan1_z1, etan1_z2] = meshgrid(etan1);
    [z1, z2] = meshgrid(z);
    
    G = zeros(1, length(qp));
    for i = 1 : length(qp)
        pause( 1e-3 )
        G(i) = sum(sum(sim2d .* etan1_z1 .* etan2_z1 .* etan1_z2 .* etan2_z2 .* exp(-qp(i) * abs(z1 - z2))));
    end
    G = G * dz * dz / 9;
    
end
