function W = WLO_opt(En1, En2, TEMP, etan2, etan1, z)
% LO Phonon Scattering rate between levels n2 and n1

    global hbaromLO e hbar Angstrom kB epsP eps0 Ndecim mw
        
    Nq = 1 / (exp(hbaromLO * e / kB / TEMP) - 1);
    
    % qp variable
    if En1 - En2 - hbaromLO > 0
        qp = sqrt(2 * mw / hbar ^ 2 * (En1 - En2 - hbaromLO) * e * Angstrom ^ 2);

        % variable etan2, etan1 and z (taken every Ndecim value of the
        % efficiency)
        etan2 = etan2(1 : Ndecim : length(etan2));
        etan1 = etan1(1 : Ndecim : length(etan1));
        z = z(1 : Ndecim : length(z));
        % time step size for z1 and z2
        dz = (z(end) - z(1)) / (length(z) -  1);

        % Simpson numerical integration for z1 and z2
        % ---------------------------------------------------------------------
        % simpson1D -> odd number
        if (rem(length(z), 2) == 0)
            z = z(1 : end - 1);
            etan1 = etan1(1 : end - 1);
            etan2 = etan2(1 : end - 1);
            % new time step size for z1 and z2
            dz = (z(end) - z(1)) / (length(z) -  1);
        end
        % simpson 1D
        sim1d = ones(1, length(z));
        sim1d = 4 * (rem(find(sim1d), 2) == 0) + 2 * (rem(find(sim1d), 2) == 1);
        sim1d(1) = 1;   
        sim1d(end) = 1;
        % simpson 2D
        [sim2d1, sim2d2] = meshgrid(sim1d);
        sim2d = sim2d1 .* sim2d2;
        % ---------------------------------------------------------------------

        % 2D meshgrid
        [etan2_z1, etan2_z2] = meshgrid(etan2);
        [etan1_z1, etan1_z2] = meshgrid(etan1);
        [z1, z2] = meshgrid(z);

        G = sum(sum(sim2d .* etan1_z1 .* etan2_z1 .* etan1_z2 .* etan2_z2 .* exp(-qp * abs(z1 - z2))));        
        G = G * dz * dz / 9;          

        W = 4 * pi ^ 2 * epsP * eps0 * hbar ^ 2 / e ^ 2 / hbaromLO * hbar / mw * qp / G / e / Angstrom / (Nq + 1);
    else
        W = 1e-30;
    end

end
