% main1 calculates subband positions at zero magnetic field and 
% corresponding wave functions

param1

% Energy range assumption
E0min = 0; % eV ***
dE0 = 0.00025; % eV ***
E0max = 0.35; % eV ***

% Memory allocation
eta123 = zeros(Nz, 100); % wave functions
E123 = zeros(1, 100); % eigenvalues

first = 1;
Nn = 0;
for E0 = E0min : dE0 : E0max
    
    [eta0, eta0Nzr] = shooting(E0);
    E0r = E0;
    
    if (first)
        first = 0;
    elseif (sign(eta0Nzl) * sign(eta0Nzr) <= 0)
        E = bisect(E0l, E0r);
        [eta, etaNz] = shooting(E);
        
        Nn = Nn + 1;
           
        eta123(:, Nn) = eta;
        E123(Nn) = E;
    end
    
    E0l = E0r;
    eta0Nzl = eta0Nzr;
end

% Rejection of the excessive memory
eta123 = eta123(1 : Nz, 1 : Nn);
E123 = E123(1 : Nn);

% Entry of the energy eigenvalues and wave functions in the file
% 'enrgwave.txt'
% -------------------------------------------------------------------------
fid = fopen('enrgwave.txt','w');

fprintf(fid, ' %d\n\n', Nn);
fprintf(fid, ' %d\n\n', Nz);

for j = 1 : Nn
    fprintf(fid, '%18.15f ', E123(j));
end
fprintf(fid, '\n\n');

for i = 1 : Nz
    for j = 1 : Nn
        fprintf(fid, '%18.15f ', eta123(i, j));
    end
    fprintf(fid, '\n');
end

fclose(fid);
% -------------------------------------------------------------------------

dlmwrite('z.txt',z);
dlmwrite('U.txt',U)
