% Set new parameters according to the constraints

function [y ptr] = newsol(x, VM, LB, UB)
ptr = find(randperm(length(x)) == length(x)); % select one parameter to change the value
y = x;
y(ptr) = y(ptr) + VM(ptr); % set new value of selected parameter
% Check new value of selected parameter
if ptr < 3 % if electric field or coefficient of alloy composite is selected
    if or(y(ptr) < LB(ptr), y(ptr) > UB(ptr))
        y(ptr) = (LB(ptr) + (UB(ptr) - LB(ptr)) * rand);
    end
else % if one dimension of structure is selected
    while ~or(and(y(ptr) >= LB(ptr), y(ptr) < 1), and(y(ptr) >= 8, y(ptr) <= UB(ptr)))
        y(ptr) = LB(ptr) + (UB(ptr) - LB(ptr)) * rand;
    end
end

end