% Callback function for "Densities". When user clicks "Densities", 
% the program will plot the ratio of the total electron areal densities 
% in the ground laser levels of the third and the second subband.

% load results from file 'res.txt'
% -------------------------------------------------------------------------
fid = fopen('res.txt','r');
NB = fscanf(fid, '%d', 1);
Bmin = fscanf(fid, '%f', 1);
dB = fscanf(fid, '%f', 1);
Bmax = fscanf(fid, '%f', 1);
TEMP = fscanf(fid, '%f', 1);
B = zeros(1, NB);
W30lo = zeros(1, NB);
W30ir = zeros(1, NB);
W30loir = zeros(1, NB);
N20lo = zeros(1, NB);
N30lo = zeros(1, NB);
N20loir = zeros(1, NB);
N30loir = zeros(1, NB);
g32lo = zeros(1, NB);
g32loir = zeros(1, NB);
for i = 1 : NB
    B(i) = fscanf(fid, '%f ', 1);
    W30lo(i) = fscanf(fid, '%f', 1);
    W30ir(i) = fscanf(fid, '%f', 1);
    W30loir(i) = fscanf(fid, '%f', 1);
    N20lo(i) = fscanf(fid, '%f', 1);
    N30lo(i) = fscanf(fid, '%f', 1);
    N20loir(i) = fscanf(fid, '%f', 1);
    N30loir(i) = fscanf(fid, '%f', 1);
    g32lo(i) = fscanf(fid, '%f', 1);
    g32loir(i) = fscanf(fid, '%f', 1);
end
fclose(fid);
% -------------------------------------------------------------------------

hold off
subplot(1,1,1,'Parent',panelFigure)
plot(B, N30lo ./ N20lo, 'b--', B, N30loir ./ N20loir, 'r','linewidth',font_scale*4)
title('Population inversion','FontWeight','bold','FontSize',font_scale*20)
xlabel('B [T]','FontSize',font_scale*20)
ylabel('N_{3,0} / N_{2,0}','FontSize',font_scale*20)
h = legend('1/\tau_{\rm LO}', '1/\tau_{\rm LO} + 1/\tau_{\rm IR}', 'Location', 'Best');
set(h, 'Box', 'off','FontSize',font_scale*20)
set(gca,'FontSize',font_scale*20)